



serial.number			equ	.220


auto.power.off.period	equ	.100	; *6 sec, range 1...255
access	equ	0
banked	equ	1

;                     ____    ____                 				
;             MCLR  >|    \__/    |X  B7  PGD					
;      ANODE 1  A0  <|            |<  B6  PGC, SW3...6 in 		
;      ANODE 2  A1  <|            |>  B5  Vdd ON/OFF			
;      ANODE 3  A2  <|            |X  B4  AUX data				
;      ANODE 4  A3  <|            |>  B3  cathode driver DATA   
;      ANODE 5  A4  <|            |>  B2  AUX clock				
;      ANODE 6  A5  <|   PIC18LF  |>  B1  cathode driver CLOCK6
;              Vss  =|    25K50   |<  B0  KEY INT				
;      ANODE 8  A7  <|            |=  Vdd            			
;      ANODE 7  A6  <|            |=  Vss            			
;  USB V detect C0  >|            |<  C7  RXD IR in				
;  CCP2 carrier C1  <|            |>  C6  TXD IR out			
;  LED out/ANin C2  X|            |X  C5  USB D+     			
;             Vcap  =|____________|X  C4  USB D-     			
;																
;	FOLLOWING DEFINITIONS ARE LOCATED IN FILE MASCROS.INC:		
;																
;	keyint			PORTB,0		key "INT" in					
;	clk				LATB,1		cathode driver CLOCK			
;	accscl			LATB,2		AUX clock out latch				
;	accscl.port		PORTB,2		AUX clock in port				
;	accscl.ts		TRISB,2		AUX clock TRIS bit				
;	sdo				LATB,3		cathode driver DATA				
;	accsda			LATB,4		AUX data out latch				
;	accsda.port		PORTB,4		AUX data in port				
;	accsda.ts		TRISB,4		AUX data TRIS bit				
;	vdd				LATB,5		Vdd ON/OFF switch				
;	keys			PORTB,6		PGC / SW3...6 input				
;	usbv			PORTC,0		USB V detect					
;																

	LIST P=18LF25K50
	#include <p18lf25k50.inc>
	#include <macros.inc>

;*******************************************************************************
;			CONFIGURATION REGISTERS (not used if firmware is bootloaded)		
;*******************************************************************************

 config PLLSEL = PLL3X      ; 3x clock multiplier
 config CFGPLLEN = ON       ; PLL Enabled
 config CPUDIV = NOCLKDIV   ; 1:1 mode
 config LS48MHZ = SYS48X8   ; System clock at 48 MHz, USB clock divider is set to 8
 config FOSC = INTOSCIO     ; Internal oscillator
 config PCLKEN = OFF        ; Primary oscillator disabled
 config FCMEN = OFF         ; Fail-Safe Clock Monitor disabled
 config IESO = OFF          ; Oscillator Switchover mode disabled
 config nPWRTEN = ON        ; Power up timer enabled
 config BOREN = OFF         ; BOR disabled
 config nLPBOR = OFF        ; Low-Power Brown-out Reset disabled
 config WDTEN = OFF         ; WDT disabled in hardware (SWDTEN ignored)
 config CCP2MX = RC1        ; CCP2 input/output is multiplexed with RC1
 config PBADEN = OFF        ; PORTB<5:0> pins are configured as digital I/O on Reset
 config MCLRE = ON          ; MCLR pin enabled; RE3 input disabled
 config STVREN = OFF        ; Stack full/underflow will not cause Reset
 config LVP = OFF           ; Single-Supply ICSP disabled
 config XINST = OFF         ; Instruction set extension and Indexed Addressing mode disabled
 config DEBUG = OFF         ; Bkgnd debugger disabled, RB6 and RB7 configured as gp I/O pins
 config CP0 = OFF           ; Block 0 is not code-protected
 config CP1 = OFF           ; Block 1 is not code-protected
 config CPB = OFF           ; Boot block is not code-protected
 config CPD = OFF           ; Data EEPROM is not code-protected
 config WRT0 = OFF          ; Block 0 (0800-1FFFh) is not write-protected
 config WRT1 = OFF          ; Block 1 (2000-3FFFh) is not write-protected
 config WRTC = OFF          ; Configuration registers (300000-3000FFh) are not write-protected
 config WRTB = OFF          ; Boot block (0000-7FFh) is not write-protected
 config WRTD = OFF          ; Data EEPROM is not write-protected
 config EBTR0 = OFF         ; Block 0 is not protected from table reads executed in other blocks
 config EBTRB = OFF         ; Boot block is not protected from table reads executed in other blocks

;*******************************************************************************
;							DATA  MEMORY										
;*******************************************************************************

	CBLOCK		0

KeyEdge			; bits 3,2,1,0 are flags, set when keys 3,2,1,0 are JUST pressed
				; must be cleared in user routine
				; bit 0 set if key 0 (INT) just pressed
				; bit 1 set if key 1 (left) just pressed
				; bit 2 set if key 2 (up) just pressed
				; bit 3 set if key 3 (down) just pressed
				; bit 4 set if key 4 (right) just pressed

Rotor0			; used for key 0 (INT) debouncer   (rotate left, bit=0 if key pressed)
Rotor1			; used for key 1 (left) debouncer  (rotate left, bit=0 if key pressed)
Rotor2			; used for key 2 (up) debouncer    (rotate left, bit=0 if key pressed)
Rotor3			; used for key 3 (down) debouncer  (rotate left, bit=0 if key pressed)
Rotor4			; used for key 4 (right) debouncer (rotate left, bit=0 if key pressed)

Flag			; bit 0 set = pause mode
				; bit 1 set = Timer interrupt (1200 Hz) handshaking (set only)
				; bit 2 set = full scan (150 Hz) handshaking (set only)
				; bit 3 set = EEPROM buffer function disabled
				; bit 4 set = INT in second cycle (OFF period)
				; bit 5 set = Only two steps for key 0, without pause
				; bit 6 set = Display message received
				; bit 7 set = column cathode

RXFlag			; bit 0 set = RX enable
				; bit 1 set = RX header reception in progress
				; bit 2 set = RX in progress
				; bit 3 set = RX message recived, flag to write terminator to EEPROM after timeout
				; bit 4 set = 
				; bit 5 set = 
				; bit 6 set = 
				; bit 7 set = 

Brightness		; display ON time, 0...15, used for dimming (15 = max brightness)
GPreg			; general purpose register
BitMask			; 10000000...00000001, shift right (CA) or 0...7 row counter (CC)
BitMask2		; 11111110...01111111, shift left
T0period		; total (OFF+ON) period for T0
InnerInt		; inner loop counter
OuterInt		; outer loop counter
OutPlusInt		; one more outer loop counter
RXptr			; low RXD buffer pointer, high is always =6
RXpatience		; Patience counter, preset to 200 ms when byte received, count down
PowerOff		; Auto Power Off period (*6sec)
PowerCount		; Auto Power Off count down
Uniform:2		; 150Hz freerunning uniform count up for 6 sec timing
RXserial:2		; received serial number BINARY, ready for comparison
MYserial:2		; serial number from ROM addr 0x100E
FSR0temp:2		; temporary FSR0 during INT

	ENDC

DispBuf		equ	0x600

Buffer		equ	0x700	; display buffer, upper row first, bit 7 = left column, bit set = LED on
Buffer2		equ	0x710	; aux buffer (not displayed by interrupt display refresh)
BufferPause	equ	0x720	; pause buffer (displayed only during pause)
Ma0			equ	0x730	; rnd seed
Ma1			equ	0x731
Ma2			equ	0x732
Ma3			equ	0x733
Mc0			equ	0x734	; rnd acc
Mc1			equ	0x735
Mc2			equ	0x736
Mc3			equ	0x737

;*******************************************************************************
;						B O O T L O A D E R   C O D E							
;*******************************************************************************

	org		0x0000
	#include <BootLoader.inc>

;*******************************************************************************
;						K E R N E L   C O D E									
;*******************************************************************************

	ORG		Offset+0x0000
	goto	ini

	ORG		Offset+0x0004
	goto	rnd.ept				; fixed address 0x1004

;*******************************************************************************
;				TIMER2 AND EXT0 INTERRUPT AND SERIAL NUMBER						
;*******************************************************************************

	org		Offset+0x0008		; T2 int 800 Hz
	#include <int.inc>

;*******************************************************************************
;							M A I N												
;*******************************************************************************

ini
;								INTERNAL OSCILLATOR
	movlw	b'01111100'		; Sleep mode on SLEEP instr, 16 MHz internal osc
	movwf	OSCCON,access
	movlw	b'00010011'
	movwf	OSCCON2,access

;						I/O PORTS
	banksel	ANSELA			; banked SFR page
	clrf	ANSELA,banked	; all inputs digital
	clrf	ANSELB,banked	; all inputs digital
	movlw	b'00000100'
	movwf	ANSELC,banked	; all inputs digital except C2 (AN14)
	banksel	Buffer			; all banked modes will address bank 7

	movlw	b'00000000'		; pull-ups enabled, int0 on falling edge of PORTB,0
	movwf	INTCON2,access
	movlw	b'01000000'
	movwf	WPUB,access		; PORTB,6 PULL UP ENABLED

	movlw	b'11111111'
	movwf	LATA,access
	movlw	b'00000010'
	movwf	LATB,access
	movlw	b'00000000'
	movwf	LATC,access

	movlw	b'00000000'
	movwf	TRISA,access
	movlw	b'01000001'
	movwf	TRISB,access
	movlw	b'10111101'
	movwf	TRISC,access

; ----------------------- timer0
	movlw	b'11000110'		; T0 on, 8 bit, prescaler=128
	movwf	T0CON,access
	movlw	.78				; int on  78*128t = 9984T  (1202 Hz)
	movwf	T0period,access

; ----------------------- timer2 and PWM2
	movlw	b'00000101'		; T2 on, prescaler 1:4, no postscaler
	movwf	T2CON,access
	movlw	.75-1			; 12MHz/(4*75) = 40KHz carrier
	movwf	PR2,access

	movlw	b'00001100'		; PWM mode
	movwf	CCP2CON,access
	movlw	b'00100110'		; period = .38
	movwf	CCPR2L,access
	clrf	CCPR2H,access

; ----------------------- UART
	movlw	b'00100000'
	movwf	TXSTA1,access	; reg TXREG, BRGH=0
	movlw	b'10010000'
	movwf	RCSTA1,access	; reg RCREG
	movlw	b'00011000'
	movwf	BAUDCON1,access	; TX inverted, brg16=1
	movlw	high .1250
	movwf	SPBRGH1,access	; 2400 baud
	movlw	low .1250
	movwf	SPBRG1,access	; 2400 baud

;-------------------------------- initialization over
	movlw	.15					; do nothing for 80 ms
	movwf	OutPlusInt
	clrf	OuterInt,access
iniloop
	decfsz	InnerInt,f,access
	bra		iniloop
	decfsz	OuterInt,f,access
	bra		iniloop
	decfsz	OutPlusInt,f,access
	bra		iniloop

; *******************************

	lfsr	FSR0,0
goclr1
	xorwf	INDF0,w,access	; uses 0x000-0x1FF for randomization and clears banks
	clrf	POSTINC0		; clears ram banks 0 and 1
	btfss	FSR0H,1,access
	bra		goclr1
	movwf	Ma0,banked		; randomizes seed 0
goclr2
	xorwf	INDF0,w,access	; uses 0x200-0x3FF for randomization and clears banks
	clrf	POSTINC0		; clears ram banks 2 and 3
	btfsc	FSR0H,1,access
	bra		goclr2
	movwf	Ma1,banked		; randomizes seed 1
goclr3
	xorwf	INDF0,w,access	; uses 0x400-0x5FF for randomization and clears banks
	clrf	POSTINC0		; clears ram banks 4 and 5
	btfss	FSR0H,1,access
	bra		goclr3
	movwf	Ma2,banked		; randomizes seed 2
goclr4
	xorwf	INDF0,w,access	; uses 0x600-0x7FF for randomization and clears banks
	clrf	POSTINC0		; clears ram banks 6 and 7
	btfsc	FSR0H,1,access
	bra		goclr4
	movwf	Ma3,banked		; randomizes seed 3

	clrf	TBLPTRU,access
	bsf		Flag,5,access	; bit 5 set = Only two steps for key 0, without pause

	movlw	.8
	movwf	Brightness,access	; Brightness initialized

	movlw	auto.power.off.period/4
	movwf	PowerOff,access
	movff	PowerOff,PowerCount	; initialize power off counter

;							serial number 									
	movlw	low (SNword)		; serial number defined in kernel
	movwf	TBLPTRL,access
	movlw	high (SNword)		; serial number defined in kernel
	movwf	TBLPTRH,access
	tblrd*+
	movff	TABLAT,MYserial+0	; lo byte
	tblrd*
	movff	TABLAT,MYserial+1	; hi byte

;								    EEPROM read									
	clrf	EECON1,access		; Disable write to EEPROM
	setf	EEADR,access		; EEADR = -1

	call	ee.rd				; incf EEADR and read addr 0 (Brightness)
	andlw	0x0F
	movwf	Brightness,access
						; load text for display
	lfsr	FSR0,DispBuf		; point dst to Display buffer
	call	ee.rd				; read first byte only from EE addr 1
	movwf	POSTINC0,access

	addlw	0
	bz		def.txt				; if first char = terminator, go load def text
	addlw	1
	bz		def.txt				; if first char = 0xFF (empty EE), go load def text

	movlw	.254				; one read, 254 more left
	movwf	GPreg,access		; temporarily borrowed register
go.rd.ee
	call	ee.rd				; incf EEADR and read char
	movwf	POSTINC0,access
	decfsz	GPreg,f,access
	bra		go.rd.ee
	bra		exit.ee
						; load default text from rom
def.txt
	lfsr	FSR0,DispBuf		; initialize dest
	movlw	low greeting
	movwf	TBLPTRL,access		; initialize src
	movlw	high greeting
	movwf	TBLPTRH,access		; initialize src
transfer.greeting
	tblrd*+						; read ACSII byte from ROM
	movf	TABLAT,w,access
	movwf	POSTINC0
	bz		exit.ee				; if message terminator 0 found
	movf	FSR0L,f,access		; dummy
	bnz		transfer.greeting	; if not EEPROM page ovf
exit.ee
;																			
	call	disp.detect			; auto detect display type (affects Flag,7)
	movlw	b'11100000'		; enable INTERRUPTS, enable timer0 int
	movwf	INTCON,access

	movlw	low (Offset+0x0800)
	movwf	TBLPTRL,access		; initialize src
	movlw	high (Offset+0x0800)
	movwf	TBLPTRH,access		; initialize src
	tblrd*+
	incf	TABLAT,w,access
	ifz							; is user program space empty?
	reset						; yes, reset
	goto	Offset+0x080C		; no, go to FARM

;***********************************************************************************;
;***********************************************************************************;
ee.rd
	incf	EEADR,f,access		; *** adv addr (1...255)
	bsf		EECON1,RD,access	; initiate READ
	movf	EEDATA,w,access		; read data
	return

;***********************************************************************************;
disp.detect
	movlw	b'00111001'		; AN14, enable ADC
	movwf	ADCON0,access
	movlw	b'00000000'		; Vref+ to AVdd, Vref- to AVss
	movwf	ADCON1,access
	movlw	b'00111110'		; Left just, 20 Tad, FOSC/64
	movwf	ADCON2,access

		bcf		sdo,ACCESS		; serial data low (shift reg outputs 1...15 off)
	variable xx
xx=0
	while xx<.15
		bcf		clk,ACCESS		; ^^^\___	generate "clk" pulse
		bsf		clk,ACCESS		; ___/^^^	shift out one bit, now it is 000000000000000x
xx+=1
	endw

	movlw	0x7F
	movwf	LATA			; switch on anode 1 only

	bsf		sdo,ACCESS		; serial data high (shift reg output 1 on)
	bcf		clk,ACCESS		; ^^^\___	generate "clk" pulse
	bsf		clk,ACCESS		; ___/^^^	shift out one bit, now it is 1000000000000000

	call	ad.convert		; * first ADC

	movwf	GPreg,access	; temporarily borrowed register

	bcf		sdo,ACCESS		; serial data low (shift reg output 1 off,output 2 on)
	bcf		clk,ACCESS		; ^^^\___	generate "clk" pulse
	bsf		clk,ACCESS		; ___/^^^	shift out one bit, now it is 0100000000000000

	call	ad.convert		; * second ADC


	setf	LATA,access		; switch off all anodes
	bcf		ADCON0,access	; disable ADC

	subwf	GPreg,w,access	; conv1-conv2
	ifnc
	bsf		Flag,7,access	; set column cathode flag if conv2>conv1
	return

ad.convert
	bsf		ADCON0,GO,access	; start conv
wait.conv
	btfsc	ADCON0,GO,access	; test ready/bysy flag
	bra		wait.conv
	movf	ADRESH,w,access		; read 8-bit result to W
	return


;***********************************************************************************;
;   32-bit pseudorandom generator													;
;   every time it is envoked, it performs SEED * 0x41c64e6d + 0x00006073 ---> SEED	;
;   At the end, it performs  Ma0 xor Ma1 plus Ma2 xor Ma3 xor TMR2 ---> w			;
;   where: Ma0 = lowest byte of SEED, Ma3 = highest byte							;
;   input:  Ma0,Ma1,Ma2,Ma3 (which is SEED), output: w, trashes: Mc0,Mc1,Mc2,Mc3	;
;   Execution time:  80T including call/ret											;
;***********************************************************************************;
rnd.ept
;	A3 A2 A1 A0 * 41 c6 4e 6d = C3 C2 C1 C0 

	banksel	Ma0

	movf	Ma0,w,banked		; a0
	mullw	0x6d				; b0
	movff	PRODL,Mc0
	movff	PRODH,Mc1			; 1

	movf	Ma0,w,banked		; a0
	mullw	0x4e				; b1
	movf	PRODL,w,access
	addwf	Mc1,f,banked		; +lo
	ifc
	incf	PRODH,f,access		; c
	movff	PRODH,Mc2			; 2

	movf	Ma1,w,banked		; a1
	mullw	0x6d				; b0
	movf	PRODL,w,access
	addwf	Mc1,f,banked		; +lo
	movf	PRODH,w,access
	addwfc	Mc2,w,banked		; +hi c
	clrf	Mc3,banked
	ifc
	incf	Mc3,f,banked		; c
	movwf	Mc2,banked			; 3

	movf	Ma0,w,banked		; a0
	mullw	0xc6				; b2
	movf	PRODL,w,access
	addwf	Mc2,f,banked		; +lo
	movf	PRODH,w,access
	addwfc	Mc3,f,banked		; +hi c   4

	movf	Ma2,w,banked		; a2
	mullw	0x6d				; b0
	movf	PRODL,w,access
	addwf	Mc2,f,banked		; +lo
	movf	PRODH,w,access
	addwfc	Mc3,f,banked		; +hi c   5

	movf	Ma1,w,banked		; a1
	mullw	0x4e				; b1
	movf	PRODL,w,access
	addwf	Mc2,f,banked		; +lo
	movf	PRODH,w,access
	addwfc	Mc3,f,banked		; +hi c   6

	movf	Ma0,w,banked		; a0
	mullw	0x41				; b3
	movf	PRODL,w,access
	addwf	Mc3,f,banked		; +lo     7

	movf	Ma3,w,banked		; a0
	mullw	0x6d				; b0
	movf	PRODL,w,access
	addwf	Mc3,f,banked		; +lo     8

	movf	Ma1,w,banked		; a0
	mullw	0xc6				; b2
	movf	PRODL,w,access
	addwf	Mc3,f,banked		; +lo     9

	movf	Ma2,w,banked		; a0
	mullw	0x4e				; b1
	movf	PRODL,w,access
	addwf	Mc3,f,banked		; +lo     10

;                  |      A0 B0    1
;                  |   A0 B1       2
;                  |   A1 B0       3
;                  |A0 B2          4
;                  |A2 B0          5
;                  |A1 B1          6
;               |A0 B3             7
;               |A3 B0             8
;               |A1 B2             9
;               |A2 B1             10

;	C3 C2 C1 C0 + 00 00 60 73 = A3 A2 A1 A0 

	clrf	Ma3,banked
	clrf	Ma2,banked
	movlw	0x60
	movwf	Ma1,banked
	movlw	0x73
	movwf	Ma0,banked

	movf	Mc0,w,banked
	addwf	Ma0,f,banked

	movf	Mc1,w,banked
	addwfc	Ma1,f,banked

	movf	Mc2,w,banked
	addwfc	Ma2,f,banked

	movf	Mc3,w,banked
	addwfc	Ma3,f,banked

	movf	Ma0,w,banked	; extra:  Ma0 ^ Ma1 + Ma2 ^ Ma3 ---> w
	xorwf	Ma1,w,banked
	addwf	Ma2,w,banked
	xorwf	Ma3,w,banked
	xorwf	TMR0,w,access
	xorwf	TMR2,w,access	; 8-bit output: w

	return

;																					
greeting
 db "<h>Welcome to<H> Hackaday Belgrade<h> conference    "
 db	"<I>H<i> <I>A<i> <I>C<i> <I>K<i> <I>A<i> <I>D<i> <I>A<i> <I>Y<I> "
 db "<v>Welcome to<V> Hackaday Belgrade<v> conference    "
 db	"<I>H<i> <I>A<i> <I>C<i> <I>K<i> <I>A<i> <I>D<i> <I>A<i> <I>Y<I> ",0

; db "ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz 01234567890 !@#$%^&*()_+-= \':[]{},./<>?",0x32,0x3b,0

	org		Offset+0x07FE		; serial number
SNword
	dw		serial.number

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  transmit header 80 pulses (4ms) + space (2 ms) + BUFFER (BYTES by)                ;
;                                                                                    ;
;           80 pulses             40      20 20 20    60    20               20      ;
; ___MMMMMMMMMMMMMMMMMMMMMMMM____________MMM___MMM_________MMM__..........__MMM___   ;
;             4ms                 2ms    .5 .5 .5   1.5ms                   .5       ;
;    |             header                | "0" |    "1"    |    ..........  | dummy  ;
;    |                                   |     |           |                |        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	END



